#!/bin/bash

# Create a fresh directory swith.
opam switch create . ocaml-base-compiler.4.11.1
eval $(opam env)

opam repo add coq-released https://coq.inria.fr/opam/released
opam repo add iris-dev https://gitlab.mpi-sws.org/iris/opam.git

opam pin add why3 https://gitlab.inria.fr/why3/why3.git

opam install -y ocamlgraph why3 why3-ide

# Build lambda-rust
pushd lambda-rust
OPAMFLAGS=-y make build-dep
make -j$(nproc)
popd

# Build Creusot
pushd creusot
echo "Installing Creusot"
source $HOME/.cargo/env
cargo install --path creusot
popd

pushd rhb-specs
CREUSOT_CONTINUE=1 cargo creusot --features=contracts > proofs.mlcfg
popd
